<template>
  <div>
    <!-- <template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="blanco" style="margin-left:5%; width:90%;">
      <div class="divCol3">
        <v-row>
          <v-col>
            Nombre de la Disciplina
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              class="mt-0 pt-1"
              autofocus
              v-model.trim="tempEditingDisciplina.descripcion"
              background-color="white"
              maxlength="50"
              persistent-hint
              hint-align="right"
              dense
              :error="$v.tempEditingDisciplina.descripcion.$error"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(
                    tempEditingDisciplina.descripcion,
                    50
                  )
              "
              @keyup.enter="saveDisciplina"
            >
              <template
                v-if="
                  $v.tempEditingDisciplina.descripcion.$error ||
                    !isUniqueDisciplina
                "
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.tempEditingDisciplina.descripcion.$reset"
                      v-close-popover
                    >
                      <div
                        v-if="!$v.tempEditingDisciplina.descripcion.required"
                      >
                        ¡No te olvides de éste campo!
                      </div>
                      <div
                        @click="isUniqueDisciplina = !isUniqueDisciplina"
                        v-if="
                          !isUniqueDisciplina &&
                            $v.tempEditingDisciplina.descripcion.required
                        "
                      >
                        ¡Encontramos su gemela! el nombre de la disciplina esta
                        duplicado
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <div align="center">
        <v-row>
          <v-col>
            <template>
              <v-btn
                small
                class="mr-2"
                depressed
                dark
                tile
                color="secundary"
                @click="cancelChanges"
                >Cancelar cambios</v-btn
              >
              <v-btn
                :class="[
                  { desac: !hasGlobalChanges },
                  { 'error-validation-btn': false }
                ]"
                @click="saveDisciplina"
                small
                depressed
                dark
                tile
                color="primary"
                >Guardar cambios</v-btn
              >
            </template>
          </v-col>
        </v-row>
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogCancel = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelTempEditDisciplina"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal" style=" text-align: center;">
              ¡Se han
              <strong
                >guardado los cambios de la disciplina "{{
                  tempEditingDisciplina.descripcion
                }}" de manera exitosa!</strong
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="finishEditingDisciplina"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSaveNew" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal" style=" text-align: center;">
              ¡Se ha
              <strong
                >guardado la disciplina "{{
                  tempEditingDisciplina.descripcion
                }}" de manera exitosa!</strong
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="finishEditingDisciplina"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="dialogErrorValidationNombreDisciplina"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Ocurrio un error al validar el nombre de la disciplina
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Ya estamos trabajando en ello,
            estaremos de regreso pronto.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidationNombreDisciplina = false"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDuplicateData" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal" style="text-align: justify;">
              <strong> ¡La disciplina ya se encuentra registrada! </strong
              ><br />
              Por favor ingresa una diferente.
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogDuplicateData = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
export default {
  props: ["data", "metadata", "finishEditingDisciplina"],
  name: "Disciplina",
  data() {
    return {
      dialogErrorValidation: false,
      tempEditingDisciplina: null,
      tempEditingDisciplinaBackup: null,
      dialogSave: false,
      dialogSaveNew: false,
      dialogCancel: false,
      dialogErrorValidationNombreDisciplina: false,
      dialogDuplicateData: false,
      isUniqueDisciplina: true
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.tempEditingDisciplinaBackup) {
        const originalValue = JSON.stringify(
          this.tempEditingDisciplinaBackup
        ).replace(/"/g, "");
        const currentValue = JSON.stringify(this.tempEditingDisciplina).replace(
          /"/g,
          ""
        );
        if (this.tempEditingDisciplina.id_disciplina === undefined) {
          if (originalValue !== currentValue) {
            return originalValue !== currentValue;
          }
          return originalValue === currentValue;
        }
        return originalValue !== currentValue;
      } else {
        return this.tempEditingDisciplina.id_disciplina === undefined;
      }
    }
  },
  validations: {
    tempEditingDisciplina: {
      descripcion: {
        required
      }
    }
  },
  methods: {
    getIndexDisciplinaFromMetadata(id_disciplina) {
      let indexDisciplinaOut;
      if (this.metadata.disciplinas) {
        this.metadata.disciplinas.forEach((itemDisciplina, indexDisciplina) => {
          if (itemDisciplina.id_disciplina === id_disciplina) {
            indexDisciplinaOut = indexDisciplina;
          }
        });
      }
      return indexDisciplinaOut;
    },
    setTempEditingDisciplina() {
      this.tempEditingDisciplina = this.data;
      this.tempEditingDisciplinaBackup = JSON.parse(
        JSON.stringify(this.tempEditingDisciplina)
      );
    },
    setEditingDisciplina(data) {
      this.tempEditingDisciplina = this.data;
      this.tempEditingDisciplinaBackup = JSON.parse(
        JSON.stringify(this.tempEditingDisciplina)
      );
    },
    cancelChanges() {
      this.dialogCancel = this.hasGlobalChanges;
      if (!this.hasGlobalChanges) {
        this.cancelTempEditDisciplina();
      }
    },
    async saveDisciplina() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        const self = this;
        if (this.tempEditingDisciplina.id_disciplina) {
          const isDisicplina = await this.existDisciplina();
          if (!isDisicplina) {
            axios
              .put("/disciplina/secure/put", this.tempEditingDisciplina)
              .then(response => {
                if (response) {
                  const data = response.data.data;
                  if (response.data.status_code === 200) {
                    if (data.updated) {
                      delete data.updated;
                      const indexDisciplina = self.getIndexDisciplinaFromMetadata(
                        data.id_disciplina
                      );
                      self.metadata.disciplinas[indexDisciplina].descripcion =
                        data.descripcion;
                      self.dialogSave = true;
                    }
                  } else {
                    console.log("No Update");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {});
          }
        } else {
          const isDisicplina = await this.existDisciplina();
          if (!isDisicplina) {
            axios
              .post("/disciplina/secure/post", this.tempEditingDisciplina)
              .then(response => {
                if (response) {
                  const data = response.data.data;
                  if (response.data.status_code === 200) {
                    if (data.inserted) {
                      self.metadata.disciplinas.push(data);
                      if (data.inserted) {
                        delete data.inserted;
                        self.setEditingDisciplina(data);
                        self.metadata.disciplinas.push(data);
                        self.dialogSaveNew = true;
                      }
                    }
                  } else {
                    console.log("No Update");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {});
          }
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    async existDisciplina() {
      if (
        this.tempEditingDisciplinaBackup.descripcion ===
          this.tempEditingDisciplina.descripcion &&
        this.tempEditingDisciplina.id_disciplina
      ) {
        return await false;
      } else {
        const self = this;
        return await axios
          .get(
            "/disciplina/secure/get/nombre?value=" +
              this.tempEditingDisciplina.descripcion
          )
          .then(response => {
            if (response) {
              if (response.data.status_code === 200) {
                const exist =
                  (response.data.track_code &&
                    response.data.track_code === 3006) === undefined;
                if (exist) {
                  self.dialogDuplicateData = true;
                  self.isUniqueDisciplina = false;
                }
                return exist;
              } else {
                return false;
              }
            }
          })
          .catch(error => {
            console.log(error);
            return false;
          })
          .finally(function() {});
      }
    },
    cancelTempEditDisciplina() {
      if (this.tempEditingDisciplina.id_disciplina) {
        let indexDisciplina;
        this.metadata.disciplinas.forEach(
          (itemDisciplina, indexItemDisciplina) => {
            if (
              itemDisciplina.id_disciplina ===
              this.tempEditingDisciplina.id_disciplina
            ) {
              indexDisciplina = indexItemDisciplina;
              this.cancelTempEditDisciplina = true;
            }
          }
        );
        this.metadata.disciplinas[
          indexDisciplina
        ].descripcion = this.tempEditingDisciplinaBackup.descripcion;
      }
      this.finishEditingDisciplina();
    }
  },
  created() {
    this.setTempEditingDisciplina();
  }
};
</script>
